//
// Functionalities for admins only
//
function capEmailImpl(InputFirstName,InputLastName,InputMail,InputMailValidity,InputEvs,InputDQH){
	//
	// Hide fields contacts pour les non admins
	//

	/* 
	var _firstName = 			$('.data_firstname .input');
	var _lastName = 			$('.data_lastname  .input');
	var _email = 				$('.data_mail .input');
	var _emailValidityStatus = 	$('.data_email_validity_status  .input');
	var _evsTxt =				$('.data_evs .input'); // =_ZPick_8R (le champ texte portant le statut du mail)
	var _DQH_RC = 				$('.data_DQH .input');
	// ??? var _form = 				$(_email).parents('form');
	*/

	var _firstName = 			$(InputFirstName);
	var _lastName = 			$(InputLastName);
	var _email = 				$(InputMail);
	var _emailValidityStatus = 	$(InputMailValidity);
	var _evsTxt =				$(InputEvs); // =_ZPick_8R (le champ texte portant le statut du mail)
	var _DQH_RC = 				$(InputDQH);
	
	if (!_email.hasClass('DQH')) {
	

		_email.addClass('DQH');
		$('head').append('<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.2.0/css/all.css" integrity="sha384-hWVjflwFxL6sNzntih27bfxkr27PmbbK/iSvJ+a4+0owXq79v+lsFkW54bOGbiDQ" crossorigin="anonymous">')
		$('head').append('<style>.fa-check{color:green;} .fa-exclamation-triangle{color:orange;} .fa-times{color:red;} .fa-cog{color:black;}; </style>');
		
		//_form.tooltip();

		
		if ($("span#check_status").length == 0) {
			$(_email).parent().append('<span style="margin-left: 0.5em;" id="check_status">');
			$("span#check_status").parent().append($('<span>').append('<i class="fas" id="check_status_icon_i">'));
		}

		
		//
		// validity_rules[code position][code value] = status
		//
		// status:
		//   0 : valid
		//   1 : no check possible
		//   2 : not valid
		var validity_rules = {
			"5": {
				"0":0,
				"1":2,
				"2":1,
				"3":1,
				"4":1,
				"5":1,
				"6":1,
				"X":1,
				"default":1
			},
			"4": {
				"0":0,
				"default":1
			},
			"3": {
				"0":0,
				"X":1,
				"default":2
			},
			"2": {
				"0":0,
				"default":2
			},
			"1": {
				"0":0,
				"default":2
			}
		};
		
		var _validity_status = {
			"-1":"<No Values>",
			"0":"valid",
			"1":"no check possible",
			"2":"not valid",
		};
		
		
		var _capmail = _email.capmail({ 
			server    			: 'https://script.google.com/macros/s/AKfycbxHH5DftbI220UUSIHqY-7LrIV_12Aw7eTYKn6_M5TEFGjbS2n2yibuAAxCoMIN50a-/exec?check=cap', 
			//server    			: 'url', 
			autocheck 			: true, 
			test	 			: true, 
			suggest   			: true, 
			last_name 			: _lastName, 
			first_name			: _firstName,
			emailValidityStatus	: "n",
			DQH_RC 				: _DQH_RC,
			country   			: "FRA",
			lang      			: "fr",
			rectify   			: 1,
			checkuser 			: "y"
		});

		_capmail.off('checking').on('checking', function() {
			_email.bootstrapState('loading');
		}).off('checked').on('checked', function(ui, data) {
			var _resSpan = $('<span>').css('font-weight', 'bolder').prop('title',data.code + ' : ' + data.state + (data.code != 0 ? ' : ' + data.msg : ''));
			var email0 = _email.val();

			var msg = data.msg;
			if (data.code == 2 && data.props) {
				//On propose une adresse corrigée uniquement si le domaine est inconnu ou s'il y a une erreur de syntaxe
				data.props.unshift({'sMail': _email.val()});
				
				$('#suggest_emails tbody tr').remove();

				for (i = 0; i < data.props.length; i++) {
					var _email_ = data.props[i].sMail;
					var _btn = $('<button>')
						.data('email', _email_)
						.text('Choose')
						.on('click',function() {
							var _reCheck = (_email.val() != $(this).data('email'));
							_email.val($(this).data('email'));
							popup_confirme_email.dialog('close');
							if (_reCheck) _email.check();
						});
					var _tr = $('<tr>')
						.append('<td>' + _email_ + '</td>')
						.append($('<td>').append(_btn));
					$('#suggest_emails tbody').append(_tr);
				}
				popup_confirme_email.dialog('open');

			}
			var _ret = "";
			data.state = (data.state == null ? '9XXXX' : data.state);
			if(data.state) {
			_DQH_RC.val(data.state);

			if(_DQH_RC.val() != '00000') {
			$('#check_status').html('Merci de vérifier votre adresse email  ');
			}
			else {
				$('#check_status').html('');
			}
			}
			var _emailValidity = checkValidity(data.state);
			_evsTxt.val(_validity_status[_emailValidity]);
			
			
			switch (_emailValidity) {
				case -1:
					_email.clearBootstrapState();
					break;
				case 0:
					_email.bootstrapState('success');
					break;
				case 1:
					_email.bootstrapState('warning');
					break;
				default:
					_email.bootstrapState('error');
			};
			$('#check_status_icon_i').prop('title',data.code + ' : ' + data.state + (data.code != 0 ? ' : ' + data.msg : ''));
			//console.info("checked : " + data.code + " / " + data.state + " / " + msg);
		}).off("keypress").on("keypress", function() {
			_email.clearBootstrapState();
		}).off("keypressed").on("keypressed", function(ui, data) {
			_email.clearBootstrapState();
			if (data && data.iRet) {
				if (data.iRet == 1) {
					_email.bootstrapState('error');
	$('#check_status_icon_i').prop('title',data.iRet + ' : ' + data.sMessage);
					$('#check_status_icon_i').tooltip({
						position:{
							of:_email,
							my:'center top',
							at:'center bottom+10'},
						hide:{
							//delay:2000
						}
					});
					$('#check_status_icon_i').tooltip('open');
					setTimeout(function(){$('#check_status_icon_i').tooltip('close');}, 2000);
				}
			}
		});



	}

	function checkValidity(dqh_rc) {
		// 
		// return :
		//    -1: no value
		//    0 : valid
		//    1 : No check possible
		//    2 : not valid
		//
		if (!dqh_rc) {
			return -1;
		}
		var _iRet = 1;
		var _checks = [];
		for(_pos = 0; _pos < dqh_rc.length; _pos++) {
			_checks[_pos] = validity_rules[_pos + 1]['default'];
			
			if (validity_rules[_pos + 1][dqh_rc.substr(_pos, 1)] != null) {
				_checks[_pos] = validity_rules[_pos + 1][dqh_rc.substr(_pos, 1)];
			}
			
		}
		iRet = Math.max(..._checks);
		return iRet;
	}
}



(function( $ ) {

    /**
     * Appelle le service CAP à partir du champ de saisie de l'adresse e-mail
     * Options disponibles :
     *   - server: URL du serveur
     *   - country: code d'un pays précis (3 caractères) OU sélecteur jQuery pointant sur le champ pays
     *   - autocheck: lance la vérification de l'adresse e-mail lorsqu'on quitte le champ e-mail (par défaut = true)
     *   - suggest: Propose des adresses e-mail en autocomplétion lors de la saisie (par défaut = false)
     *   - last_name: sélecteur jquery qui pointe sur le champ nom
     *   - first_name: sélecteur jquery qui pointe sur le champ prénom
     *   
     *   Méthodes disponibles :
     *   - check(): lance manuellement le contrôle de l'adresse e-mail
     *
     * Evènements disponibles :
     *   - checking: se lance juste avant la vérification d'une adresse e-mail
     *   - checked(data): se lance dès qu'une adresse e-mail est validée

     *
     * @param {object} options Tableau associatif des options
     * @returns {jQuery}
     */
    $.fn.capmail = function(options) {

        var myCAP = this;
		/*
        if (myCAP.hasClass('capmail')) {
			return myCAP;
		}
		myCAP.addClass('capmail');
		*/
		
		
		myCAP.chrome = /chrom(e|ium)/.test(navigator.userAgent.toLowerCase());
		
		
		
        //On initialise le conteneur du champ et l'icône de statut s'il y en a (uniquement pour des champs Bootstrap)
        var myCAPContainer = myCAP.closest('div');
        var myCAPIcon = false;
        var myCAPIconMode = false;
        if (myCAPContainer.length) {
            myCAPIcon = myCAPContainer.find('span.glyphicon');
            if (myCAPIcon.length) myCAPIconMode = 'glyphicon';
            else myCAPIcon = myCAPContainer.find('i.fas');
            if (myCAPIcon.length) myCAPIconMode = 'fas';
            else myCAPIcon = false;
        }
        else myCAPContainer = false;
		
		// cache pour les adresses email / DQH_RC
		var cache = {};
		
        var settings = $.extend({
            //Paramètres par défaut
            country: 'FRA',
            suggest: false,
            autocheck: true,
            license: '',
            extendedsyntax: 'n',
            checkuser: 'y',
            rectify: 0,
			test: true
        }, options);
        myCAP.settings = settings;

        //On récupère les champs à partir de leur selecteur
        myCAP.server     			= settings.server;
        myCAP.license    			= settings.license;
        myCAP.suggest    			= settings.suggest;
        myCAP.last_name  			= settings.last_name 			? $(settings.last_name) 			: false;
        myCAP.first_name 			= settings.first_name 			? $(settings.first_name) 			: false;
		
		myCAP.emailValidityStatus 	= settings.emailValidityStatus 	? $(settings.emailValidityStatus) 	: $('<input type=texte id="_emailValidityStatus_"');
		myCAP.DQH_RC              	= settings.DQH_RC 				? $(settings.DQH_RC) 				: $('<input type=texte id="_DQH_RC_"');
        myCAP.autocheck  			= settings.autocheck 			? settings.autocheck 				: false;
		myCAP.country    			= settings.country 				? settings.country 					: 'FRA';
		myCAP.lang       			= settings.lang    				? settings.lang    					: 'en';		
        myCAP.rectify    			= !!settings.rectify;
        myCAP.extended   			= settings.extendedsyntax === 'y' ? 'y' : 'n';
        myCAP.checkuser  			= !settings.checkuser || settings.checkuser === 'y' ? 'y' : 'n';
		myCAP.test					= settings.test;

		myCAP.previousChecked = 	{
			"val"  : myCAP.val(), 
			"code" : myCAP.DQH_RC.val()
		};
		myCAP.previousKeypressed = 	{
			"val"  : "", 
			"iRet" : 0
		};
		
		cache[myCAP.val()] = myCAP.DQH_RC.val();
		/*
        myCAP.countryField = settings.country.length === 3 ? false : $(settings.country);
        myCAP.country = settings.country;
		*/
        myCAP.asmx = myCAP.server.toLowerCase().indexOf(".asmx") > -1;

        //Paramètres d'appel AJAX par défaut pour .net
        if (myCAP.asmx) {
            $.ajaxSetup({
                type: "POST",
                contentType: "application/json; charset=utf-8",
                data: "{}",
                processData: false,
                dataFilter: function(data) {
                    if (typeof (JSON) !== 'undefined' && typeof (JSON.parse) === 'function') data = JSON.parse(data);
                    else data = eval('(' + data + ')');
                    if (data.hasOwnProperty('d')) return data.d;
                    return data;
                }
            });

            $.ajaxPrefilter(function(options, originalOptions, jqXHR) {
                options.data = JSON.stringify(originalOptions.data);
            });
        }

        if (myCAP.server === 'jsonp') {
            myCAP.ajax = function(url, callback) {
                $.ajax({
                    url: url,
                    dataType: 'jsonp',
                    jsonp: 'callback',
                    success: function(data) {
                        callback(JSON.parse(data));
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        var response = {code: 99, msg: 'Service non disponible', state: 'error'};
                        callback(response);
                        myCAP.trigger('checked', [response]);
                        //myCAP.bootstrapState(response.state);
                    }
                });
            };
        }
        else if (myCAP.server === 'cors') {
			myCAP.ajax = function(url, callback) {
				$.ajax({
					url: url,
					method: 'GET',
					dataType: 'text',
					crossdomain: true,
					success: function(data) {
						var response = data ? JSON.parse(data) : {};
						myCAP.trigger('checked', [response]);
						callback(response);
					}
				});
			};
		}
		else if (myCAP.server === 'url') {
			myCAP.ajax = function(url, callback) {
				$.ajax({
					url: url,
					method: 'GET',
					dataType: 'json',
					headers:{'Authorization':'Basic ZXVyb21hc3RlcjpkR3U0WHk2OThU'},
					success: function(data) {
						//var response = data ? JSON.parse(data) : {};
						//myCAP.trigger('checked', [data]);
						callback(data);
					},
					error: function (jqXHR, textStatus, errorThrown) {
						var response = {code: '9XXXX', msg: 'Service non disponible', state: 'error'};
						callback(response);
						myCAP.trigger('checked', [response]);
						//myCAP.bootstrapState(response.state);
					}
				});
			};
		} 
		else {
		myCAP.ajax = function (url, callback) {
				$.ajax({
					url: myCAP.server,
					data: {url: url},
					method: 'POST',
					dataType: 'json',
					success: function (data) {
						callback(data);
					},
					error: function (jqXHR, textStatus, errorThrown) {
						var response = {code: '9XXXX', msg: 'Service non disponible', state: 'error'};
						callback(response);
						myCAP.trigger('checked', [response]);
						//myCAP.bootstrapState(response.state);
					}
				});
			};
		}
	
        
        myCAP.render_item = function (ul, item) {
            var s = item.label;
            var p = s.indexOf("@");
            var highlighted;
            if (p > -1) {
                var user = s.substr(0, p);
                var domain = s.substr(p + 1);
                //#3276b4 ou #69f
                p = domain.lastIndexOf(".");
                if (p > -1) {
                    domain = '<span style="color:#070">' + domain.substr(0, p) + '</span><span style="color:#888">' + domain.substr(p) + '</span>';
                }
                else domain = '<span style="color:#070">' + domain + '</span>';
                highlighted = '<span style="color:#3276b4">' + user + '</span>@' + domain;
            }
            else {
                highlighted = '<span style="color:#3276b4">' + s + '</span>';
            }

            return $("<li></li>")
                .data("item.autocomplete", item)
                .append("<div>" + highlighted + "</div>")
                .appendTo(ul);
        };

        myCAP.remove_accents = function(s) {
            var ko = 'ÀÁÂÃÄÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÇçàáâãèéêëîïòôõöùúûüñ';
            var ok = 'AAAAAEEEEIIIIOOOOOUUUUCcaaaaeeeeiioooouuuun';
            var len = s.length;
            var p;
            var c;
            var result = "";
            for (var i = 0; i < len; i++) {
                c = s.charAt(i);
                p = ko.indexOf(c);
                result += p === -1 ? c : ok.charAt(p);
            }
            return result;
        };
        
        myCAP.check = function() {
            var input = myCAP.val();
            if (input) {
                
                var clean_mail = myCAP.remove_accents(input);
                var autocorrect = false;
                if (clean_mail !== input) {
                    myCAP.val(clean_mail);
                    autocorrect = true;
                }		
				// verif si email en cache
				if (myCAP.val() in cache) {
					var response = {code: 0, msg: '', state: cache[myCAP.val()], props: []};
					myCAP.trigger('checked', [response]);						
				}	
				// On ne checke pas une adresse email dejà checkée
				
				if (
					(myCAP.val() in cache && cache[myCAP.val()] != '') ||
					//(!myCAP.DQH_RC || (myCAP.DQH_RC && myCAP.DQH_RC.val() != '')) && 
					( myCAP.previousKeypressed.iRet != 0 &&
					  myCAP.previousKeypressed.iRet != 2)
					) {
				
					return;
				}
				myCAP.previousChecked.val = myCAP.val();
				
                myCAP.trigger('checking');
                myCAP.bootstrapState('loading');
				
				
				//var parameters = {request: "CheckMailSrvWS", sMail: clean_mail};
                //var parameters = {request: "CheckMailProp", sMail: clean_mail, sLangue: myCAP.lang};
				// Reco CAP Adresse
                var parameters = {request: "CheckMailSrvWS", sMail: clean_mail, sLangue: myCAP.lang};

                var url = myCAP.url(parameters);
                myCAP.ajax(url, function(data) {
					console.log("CheckMailSrvWS : " + JSON.stringify(data));	
                    var ko = {state: '9XXXX', msg: 'Technical error', state: 'error', code: -1};
                    if (!data || !data["response"] === "CheckMailSrvWS") return ko;

                    var code = data['iRet'];

                    var response = {code: code, msg: data['sMessage'], state: data['sCodeTraitement'], props: data['Mail']};
                    myCAP.trigger('checked', [response]);
					cache[myCAP.val()] = myCAP.DQH_RC.val();
                    //myCAP.bootstrapState(response.state);
                });
            } else {
				myCAP.trigger('checked', [{state:'', msg:'', state:''}]);
			}
        };

        myCAP.isIE = function() {
            var ua = navigator.userAgent;
            return ua.indexOf("MSIE ") > -1 || ua.indexOf("Trident/") > -1 || ua.indexOf('Edge/') > -1;
        };
        
        myCAP.clearBootstrapState = function() {
            if (myCAPContainer) myCAPContainer.removeClass('has-success').removeClass('has-warning').removeClass('has-error');
            if (myCAPIcon) {
                if (myCAPIconMode == 'glyphicon') myCAPIcon.removeClass('glyphicon-ok').removeClass('glyphicon-warning-sign').removeClass('glyphicon-remove');
                else myCAPIcon.removeClass('fa-check').removeClass('fa-exclamation-triangle').removeClass('fa-times').removeClass('fa-spin').removeClass('fa-cog');
				myCAPIcon.prop('title','');
            }
			
        };
        
        myCAP.bootstrapState = function(state) {
            myCAP.clearBootstrapState();
            if (state) myCAPContainer.addClass("has-" + state);
            var signs, sign;
            if (myCAPIcon) {
                if (myCAPIconMode === 'glyphicon') {
                    //glyph icons
                    signs = {success: 'ok', warning: 'warning-sign', error: 'remove'};
                    sign = signs[state];
                    if (state) myCAPIcon.addClass("glyphicon-" + sign);
                }
                else {
                    //font-awesome
                    signs = {success: 'check', warning: 'exclamation-triangle', error: 'times', loading: 'cog'};
                    sign = signs[state];
                    if (state) myCAPIcon.addClass("fa-" + sign);
                    if (state == 'loading' && !myCAP.isIE()) myCAPIcon.addClass("fa-spin");
                }
            }
        };

        myCAP.selected_country  = function() {
            if (myCAP.countryField) return myCAP.countryField.val();
            return myCAP.country;
        };

        myCAP.removeAutocomplete = function(element) {
            if (element.data('ui-autocomplete')) {
                element.autocomplete("destroy");
                element.removeData("ui-autocomplete");
            }
        };
        
        if (myCAP.autocheck) {
            myCAP.on('blur', function() {
                myCAP.check();
            });
        }
        
        if (myCAP.suggest) {
            myCAP.removeAutocomplete(myCAP);
            myCAP.autocomplete({
                source: function(request, response) {

					var last = myCAP.last_name ? myCAP.remove_accents(myCAP.last_name.val().toLowerCase()) : '';
                    var first = myCAP.first_name ? myCAP.remove_accents(myCAP.first_name.val().toLowerCase()) : '';
                    var input = myCAP.remove_accents(request.term.toLowerCase());
					if(input == myCAP.previousKeypressed.val) {
						return;
					}
					myCAP.previousKeypressed.val = input;
					// Done
                    var url = myCAP.url({request: "SearchMailCivWS", sNom: last, sPrenom: first, sInput: input, sPays: myCAP.country, sLangue: myCAP.lang});
                    var suggestions = {};
                    myCAP.ajax(url, function(data) {
						console.log("SearchMailCivWS : " + JSON.stringify(data));
						if (data != null && data.iRet != null) {
							myCAP.previousKeypressed.iRet = data.iRet;
							if(data.iRet == 0 || data.iRet == 2) {
								myCAP.DQH_RC.val('');
							} else {
								myCAP.DQH_RC.val('XXXXX');
							}
							myCAP.trigger('keypressed', data);
						}
                        if (!data || !data['Mail']) {
							suggestions = [];
						} else {
							suggestions = data['Mail'].map(function(item){
								return item.sMail;
							});
						}
                        response(suggestions);
                    });
                },
                minLength: 0,
                delay: 0,
                create: function() {
                    $(this).data('ui-autocomplete')._renderItem = myCAP.render_item;
                },
                open: function(event, ui) {
                    $('.ui-autocomplete').css('max-height', '150px').css('overflow-y', 'auto').css('overflow-x', 'hidden');
                },
                select: function(event, ui) {
                    myCAP.trigger('suggest', ui.item);
                    return true;
                },
                close: function( event, ui ) {
                    var value = $(this).val();
                    if (value && value.charAt(value.length - 1) === "@") {
                        $(this).autocomplete("search", value);
                    }
                },
                focus: function(event, ui) {
                    event.preventDefault();
                }
            }).focus(function() {
                if ($(this).data('ui-autocomplete')) $(this).autocomplete("search", $(this).val());
            });
			myCAP.attr('autocomplete',(myCAP.chrome ? 'cap-mail' : 'off'));
        }

        myCAP.url = function(data) {
			var _server = {true:"https://dev.capadresse.com/?", false:"https://ws2.capadresse.com:443/?"};
            var parameters = [];
            for (var key in data) {
                if (!data.hasOwnProperty(key) || key === "fn" || key === "server") continue;
                parameters.push(key + "=" + encodeURIComponent(data[key]));
            }
			parameters.push('id=3dt65kguqes94x98d4gf');
            return _server[myCAP.test] + parameters.join("&");
        };
        
        //On enlève les icônes affichant l'état lorsque le champ est modifié
        if (myCAPIcon) {
            myCAP.on("keypress", function() {
                myCAP.clearBootstrapState();
            });
        }
        return myCAP;
    };

}( jQuery ));